/*
	MDEL32 3.2  20/9/99 Copyright (c) 1991~1998 Marco Savegnago

	Multi-pattern file remover.

	Usage: MDEL [options] [d:][path]filename [&|!] [filename] ...

	options:

	-Q ask before delete file
	-R recourse subdirectories
	-S simulate


   Revision ported in win32 and stl

   Questa versione e' compilabile con:
   -	Borland C++ 4.X & STL HP (self modificate per funzionare senza warning e duplicazioni di funzioni)
   -	Borland C++ 5.X e STL fornite direttamente da compilatore
   -    Borland C++ Builder 3 e STL fornite direttamente da compilatore
   -    Borland C++ Builder 4 SP1 e STL fornite direttamente da compilatore
   -	Microsoft Visual C++ 4.X e STL fornite dal compilatore
   -	Microsoft Visual C++ 5.X e STL fornite dal compilatore
   -	Microsoft Visual C++ 6.X e STL fornite dal compilatore

   Le condizioni in cui ho sviluppato il programma:

	BC++ 4.53 su Windows for Workgroup 3.11 & Win32s 1.30.166
	BC++ 5.x & VC++ 4.x su Windows NT 4.0
	BC++ 5.x & VC++ 5 SP3 su Windows NT 4.0 SP3
	BC++ 5.x & VC++ 6 SP3 su Windows NT 4.0 SP5

	A cosa serve il programma....

	C'era una volta una azienda di nome Borland (oggi dopo svariati anni di perdite economiche e delle sue migliori
	teste e' diventata Inprise) che agli inizi degli anni '90 commercializzo' il secondo compilatore C++ disponibile
	(primo era stato lo Zortech) per PC che funzionava in MSDOS (e aderiva all'allora C++ 2.0 o 2.1 forse), ma certamente
	PRIMO per l'introduzione di un ambiente di sviluppo (IDE testo ma basato su Turbo Vision) che (secondo me) lascio'
	il segno. Per la cronaca la Microsoft intrudusse il suo ambiente di sviluppo integrato nella versione 7 del suo compilatore.
	Prima di Turbo C++ 1.0 c'erano stati nell'87 il Turbo C 1.0 l'1.5 e nell'88 la (allora) notevole 2.0 (3 dischi da 720KB
	tutto compreso).

	L'impatto con il pubblico fu notevole, visto che nei successivi anni la serie dei compilatori (arrivata alla versione 3.1 parlo
	della versione DOS) la casa madre affermo' di averne venduti oltre un milione di copie!

	Tra le pieghe del compilatore (le subdirectory), la Borland inseri' la libreria C++ Class Library, una container
	class library object based che forniva alcuni tipi di container predefiniti e i rispettivi iteratori.

	Questa libreria, (trasformata poi in template based e rinominata Borland International Data Structures) fu una
	delle prime cose che vidi scritta in un linguaggio che assomigliava sitnatticamente al C ma che aveva un 
	approccio diverso per ottenere il risultato.

	L'uso di questa libreria fu molto propedeutico per me, sopratutto per arrivare ad assimilare le tecniche object
	oriented che poi nel corsi degli anni ho visto applicare anche ad altri linguaggi.
	
	Scusate questa premessa ma la ritenevo una cosa dovuta a chi (la Borland International Inc.) ha contribuito in 
	maniera determinante alla mia carriera professionale.

	.... Avevamo cominciato con chiederci a cosa servisse questo programma ....
	
	
	Da sempre, le directory di lavoro dove viene prodotto il software si riempiono di file inutili, prove e ogni 
	tanto occorre fare un po' di pulizia chirurgica...
	
	MDEL serve a questo. In unione a un eventuale batch che lo lancia, serve a cancellare gruppi di file
	specificati con una sintassi semplice da usare.
	
	I comandi vengono impartiti a linea di comando e contengono i nomi dei file (o i wildcard) e i comandi che
	indicano che il nome che segue sara' incluso tra quelli da cancellare o escluso.

	Ad esempio Scrivendo:

	MDEL *.OBJ & *.SYM

	si cancellano tutti i files con estensione OBJ e SYM presenti nella directory.

	La stessa cosa e' ottenibile scrivendo:

	MDEL *.OBJ *.SYM

	visto che il comando & (AND) e' attivo per default.

	Nel caso in cui fosse necessario specificare un nome da non comprendere tra quelli risultanti dalla lista di
	inclusione e' necessario specificarlo di seguito al comando ! (NOT) usando la sintassi:

	MDEL *.OBJ ! PROVA.OBJ

	si cancellano tutti i files con estensione OBJ ma non PROVA.OBJ


	Naturalmente le righe possono essere molto piu' elaborate, e se non sono sufficenti i caratteri disponibili nel
	prompt della console basta scrivere tutto all'interno di un file e questo specificarlo come argomento preceduto
	dal carattere @.

	Es:

	MDEL @INCLUDE.LST ! @EXCLUDE
	
	
	Esegue il comando elaborando il contenuto del file INCLUDE.LST e EXCLUDE.LST


	MDEL *.* ! PROVA.BAK PROVA1.BAK PROVA2.BAK

	Cancella l'intera directory tranne i file specificati PROVA.BAK PROVA1.BAK e PROVA2.BAK

	I comando vengono interpretati da sinistra verso destra e valgono finche' non ne viene indicato un altro es:


	MDEL *.AAA *.BBB *.CCC *.DDD

	e' come scrivere 

	MDEL *.AAA & *.BBB & *.CCC & *.DDD

	e vuol dire cancella *.AAA *.BBB *.CCC e *.DDD


	MDEL *.* ! *.AAA *.BBB *.CCC *.DDD

	e' come scrivere

	MDEL *.* ! *.AAA ! *.BBB ! *.CCC ! *.DDD

	e vuol dire cancella tutto ma non *.AAA *.BBB *.CCC e *.DDD


	MDEL *.* ! *.AAA & *.BBB *.CCC ! *.DDD

	e' come scrivere 

	MDEL *.* ! *.AAA & *.BBB & *.CCC ! *.DDD

	e vuol dire cancella tutto (compresi *.BBB e *.CCC) ma non *.AAA *.DDD


	Importante:
		il parametro -R consente di estendere le stesse regore alle eventuali subdirectory.
		il parametro -S consente di simulare il funzionamento del programma (utile per comprendere la sintassi!)


	Questa versione e' notevolmente diversa dall'originale che funzionava in DOS con TC++ 1.0 e TCLASS, funziona
	in Win32 console mode ed e' compilabile con i compilatori di cui sopra..

	La Standard Template Library ha fatto la sua comparsa ormai da qualche anno e sebbene con qualche difficolta'
	iniziale ora la so' usare abbastanza, grazie comunuque alla logica object oriented acquisita negli anni..

	Marco Savegnago

	Agosto 1998

*/

//	RTL include

#ifdef	__BORLANDC__
#include <dir.h>
#include <iostream.h>
#include <iomanip.h>
#include	<fstream.h>
#endif

#ifdef	_MSC_VER
#include <direct.h>
#include	<windows.h>
#include	<iostream>
#include	<iomanip>
#include	<fstream>
#endif

#include	<stdio.h>
#include	<ctype.h>
#include	<dos.h>
#include	<io.h>
#include	<errno.h>
#include	<conio.h>
#include	<stdlib.h>

//	STL include

#if defined(__BORLANDC__)
	#if 	(__BORLANDC__ <= 0x462)  // Borland C++ fino alla 4.53

	#include	<cstring.h>
	#include	<stl\list.h>
	#include	<stl\algo.h>

	typedef	list<string>					stringList;
    typedef	list<string>::iterator		    stringListIterator;

	extern unsigned _stklen = 0x2000;

	#else

	#include 	<list>
	#include	<string>

	using namespace std;

	typedef	list<string>					stringList;
    typedef	list<string>::iterator		    stringListIterator;

	extern unsigned _stklen = 0x2000;

	#endif

#elif defined (_MSC_VER)		//	VC++ & BC++ accettano gli header files senza estensione
#include	<string>
#include	<list>
#include <algorithm>

using namespace std;

typedef	allocator<string>					stringAllocator;
typedef	list<string, stringAllocator>	stringList;
typedef	list<string>::iterator			stringListIterator;

#endif


class	TMdel
{
public:
	TMdel();
	int			main(int na, char **a);

private:

	static	int __stdcall ctrlBreakHandler( DWORD dw_CtrlType );
	void 		usage();
	int 		getResp();
	void 		showError();
	int 		delFiles(char *psz_path);

	stringList	IncludeList;
	stringList	ExcludeList;

	bool		b_recourseDirectory;
	bool		b_queryDeletion;
	bool		b_testMode;
	int		i_numOfMatch;
	long 		l_fileSel;
};

TMdel::TMdel()
:
	b_recourseDirectory(false),
	b_queryDeletion(false),
	b_testMode(false),
	i_numOfMatch(0),
	l_fileSel(0L)
{
}

int __stdcall TMdel::ctrlBreakHandler( DWORD dw_CtrlType )
{
	if( dw_CtrlType == CTRL_C_EVENT || dw_CtrlType == CTRL_BREAK_EVENT )
	{
		cerr << ("Ctrl-Break pressed! Program aborted");
		ExitProcess(2);
		return true;
	}
	else
		  return false; // Don't handle 'CLOSE', 'LOGOFF' or 'SHUTDOWN' events.
}

// print usage msg to stderr when the args in command line is less than 2

void TMdel::usage()
{
    cerr
        << "\n"
        << "MDEL32 (Win32) 3.2 " __DATE__ " - Copyright (c) 1991~1998 Marco Savegnago\n\n"

        << "Multi-pattern file remover\n\n"

        << "Usage: MDEL [options] [d:][path]filename [&|!] [filename] [@filelist]...\n"

        << "options:\n\n"

        << "  -Q ask before delete file\n"
        << "  -R recourse subdirectories\n"
        << "  -S simulate\n"

        << endl
	;
}

int TMdel::getResp()
{
    char	c_rsp;

    do
    {
        c_rsp=char(toupper(getch()));
        if(c_rsp=='\x03') return ('Q');
    }
    while (c_rsp != 'Y' && c_rsp != 'N' && c_rsp != 'X' && c_rsp !='Q');

    putchar(c_rsp);
    putchar('\n');

    return(c_rsp);
}

// Show the error message

void TMdel::showError()
{
	switch(errno)
	{
#ifdef	__BORLANDC__
		case ECURDIR:
			cerr << "Attempted to remove current directory" << endl;
			break;
#endif	//	__BORLANDC__
		case ENODEV :
            cerr	<< "Invalid device!" << endl;
			break;
#ifdef	__BORLANDC__
		case ENOFILE :
		case ENOPATH :
#elif	defined (_MSC_VER)
		case ENOENT:
#endif
			cerr	<< "Invalid path or filename!" << endl;
			break;
		case EACCES :
			cerr	<< "Permission denied!" << endl;
			break;
		default:
			cerr	<< "I/O Error number:" << errno << endl;
			break;
	}
}

class	matchFilename
{
public:
	char 	sz_drive[_MAX_DRIVE];
	char 	sz_dir[_MAX_DIR];
	char 	sz_filename[_MAX_FNAME];
	char	sz_extname[_MAX_EXT];
	char	sz_filePattern[_MAX_FNAME];
	char	sz_extPattern[_MAX_EXT];

	matchFilename		(const char*	cpsz_fname);

#if  defined __BORLANDC__ && 	(__BORLANDC__ <= 0x462)  // Borland C++ fino alla 4.53
	bool	operator() 	(string*	psc_pattern);
#else
	bool	operator() 	(string		sc_pattern);
#endif

	bool	match_fname (char *csz_fname, char *csz_pattern);
};

matchFilename::matchFilename(const char*	cpsz_fname)
{
	_splitpath(cpsz_fname,sz_drive,sz_dir,sz_filename,sz_extname);
}

#if  defined __BORLANDC__ && 	(__BORLANDC__ <= 0x462)  // Borland C++ fino alla 4.53
bool	matchFilename::operator() (string*	psc_pattern)
{
	_splitpath(psc_pattern.c_str(),sz_drive,sz_dir,sz_filePattern,sz_extPattern);
	return (match_fname(sz_filename,sz_filePattern) & match_fname(sz_extname,sz_extPattern));
}
#else
bool	matchFilename::operator() (string	sc_pattern)
{
	_splitpath(sc_pattern.c_str(),sz_drive,sz_dir,sz_filePattern,sz_extPattern);
	return (match_fname(sz_filename,sz_filePattern) & match_fname(sz_extname,sz_extPattern));
}
#endif

bool	matchFilename::match_fname (char *psz_fname, char *psz_pattern)
{
	register char*	p;
	register char*	f;
	bool 			b_match=true;
	bool			b_skip=false;

	if (*psz_pattern=='*')
		return true;

	if ( strpbrk(psz_pattern, "*?") )
	{
   	if (!strchr(psz_pattern,'*') && (strlen(psz_pattern) != strlen(psz_fname)))
      	return false;

		p=psz_pattern;
		f=psz_fname;

		while(*f && *p && !b_skip)
		{
      		switch (*p)
	    	{
	    		case '*':
                {
					b_skip=true;
					break;
                }
	    		case '?':
					break;
	    		default:
                {
					if(toupper(*f) != toupper(*p))
					{
		    			b_match=false;
		    			b_skip=true;
					}
					break;
                }
	    	}
	    	p++;
			f++;
		}
	}
	else
		if (stricmp(psz_fname,psz_pattern))
      		b_match=false;

   return (b_match);
}


void	printElement(string* psc_value)
{
	cout	<<	*psc_value << endl;
}


int TMdel::delFiles(char *psz_path)
{
	char 		sz_dirSearch[_MAX_PATH];
	char		sz_dirPath[_MAX_PATH];
	char		sz_delFile[_MAX_PATH];

	HANDLE            h_Search;
	WIN32_FIND_DATA   findData;

	strcpy(sz_dirSearch,psz_path);
	strcpy(sz_dirPath,sz_dirSearch);
	strcat(sz_dirSearch,"*.*");

   // Look for a file
	h_Search = FindFirstFile (sz_dirSearch, &findData);

	if (!h_Search || h_Search == (HANDLE) -1)
	{
		showError();
		return true;
	}

	// for each file in the directory check if its name match the pattern
	// list

	do
	{
		bool 	b_deleteOk=false;
		bool	b_deleteNo=false;

		if (*findData.cFileName != '.')// && !(findData.dwFileAttributes &  FILE_ATTRIBUTE_DIRECTORY))
		{
			strcpy(sz_delFile,sz_dirPath);
			strcat(sz_delFile,findData.cFileName);

			if (findData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)    /* if the filename is a subdir then */
			{
         	if(b_recourseDirectory)
				{
					strcat(sz_delFile,"\\");

					if(delFiles(sz_delFile))
						return(1);
				}
			}
			else
			{
				if (!IncludeList.empty())
				{
#if  defined __BORLANDC__ && 	(__BORLANDC__ <= 0x462)  // Borland C++ fino alla 4.53
					stringListIterator	iter	=	find_if(IncludeList.begin(), IncludeList.end(), matchFilename(findData.cFileName));

					if(*iter)
               			b_deleteOk=true;
#else
					stringListIterator iter	=	find_if(IncludeList.begin(), IncludeList.end(), matchFilename(findData.cFileName));

					if(iter != IncludeList.end())
               			b_deleteOk=true;
#endif
				}
				else
					b_deleteOk=true;

				if (!ExcludeList.empty())
				{
#if  defined __BORLANDC__ && 	(__BORLANDC__ <= 0x462)  // Borland C++ fino alla 4.53
					stringListIterator	iter	=	find_if(ExcludeList.begin(), ExcludeList.end(),matchFilename(findData.cFileName));

					if(*iter)
						b_deleteNo=true;
#else
					list<string>::iterator iter	=	find_if(ExcludeList.begin(), ExcludeList.end(),matchFilename(findData.cFileName));

					if(iter != ExcludeList.end())
	               		b_deleteNo=true;
#endif
				}

				if (b_deleteOk && !b_deleteNo)
				{
					int i_rpt=0;

					if (!b_testMode)
					{
						if(b_queryDeletion)
						{
							while(!i_rpt)
							{
								cout	<< "Delete file " << sz_delFile <<" ? [Yes/No/X/Quit] ";

								switch (getResp())
								{
									case 'Y':   // Case Yes delete!
										i_rpt=1;
										break;
									case 'N':   //	Don't delete
										i_rpt=2;
										break;
									case 'X':   // No longer ask for delete/remove
										i_rpt=1;
										b_queryDeletion=false;
										break;
									case 'Q':   // Stop execution
										return(1);
									default:
										i_rpt=0;
										break;
								}
							}
						}

						if (!b_queryDeletion || (b_queryDeletion && i_rpt==1))
						{
							if(remove(sz_delFile)==-1)
							{
								showError();
								return(1);
							}
						}
					}

					cout << "File " << sz_delFile << " deleted!" << endl;

					i_numOfMatch++;

					l_fileSel+=(findData.nFileSizeHigh * MAXDWORD) + findData.nFileSizeLow;

				}
			}
		}
	}
	while(FindNextFile (h_Search, &findData));

	FindClose(h_Search);

	return (0);
}


// The main thing

int TMdel::main (int na, char** a)
{
	char	sz_path[_MAX_PATH];
	char	sz_drive[_MAX_DRIVE];
	char	sz_dir[_MAX_DIR];
	char	sz_name[_MAX_FNAME];
	char	sz_ext[_MAX_EXT];
	char	sz_currentPath[_MAX_PATH];
	bool 	b_AND=true;
	bool	b_firstArg=true;
	bool	b_selectInclude=false;

	// check the number of args
	// if less of 2 then print usage message

	if (na < 2)
	{
		usage();
		return -1;
	}

	SetConsoleCtrlHandler( &TMdel::ctrlBreakHandler, TRUE );

   // parse command line parameter and fill the 2 simple list:

   // Ok_List contens the match pattern
   // Ko_List contens the don't match pattern

	for(int i=1; i<na; i++)
	{
   	char* p=a[i];

		if(*p == '&')
		{
      		if(*(p+1) == NULL)
			{
         		if(!b_firstArg)
					b_AND=true;
				else
				{
					b_firstArg=false;
#ifdef	__BORLANDC__
					getcwd (sz_currentPath, sizeof(sz_currentPath));
#else
					_getcwd (sz_currentPath, sizeof(sz_currentPath));
#endif
					strcat (sz_currentPath,"\\");
				}
				continue;
			}
			else
				b_selectInclude=true;
		}

		if(*p == '!')
		{
			if(*(p+1) == NULL)
			{
				b_AND=false;
				if(b_firstArg)
				{
					b_firstArg=false;
#ifdef	__BORLANDC__
					getcwd (sz_currentPath, sizeof(sz_currentPath));
#else
					_getcwd (sz_currentPath, sizeof(sz_currentPath));
#endif
					strcat (sz_currentPath,"\\");
				}
				continue;
			}
			else
				b_selectInclude=true;
		}

		if (*p == '@')
		{
			if(*(++p) != NULL)
			{
				if(b_firstArg)
					b_firstArg=false;

				ifstream listfile(p);

				if(!listfile)
				{
					cout << "Error opening List File " << p << endl;
					return 1;
				}

				char sz_filename[_MAX_PATH];

				while(listfile && listfile >> sz_filename)
				{
					string *argstr = new string(sz_filename);

                    if (b_AND)
                        IncludeList.push_front(*argstr);
                    else
                        ExcludeList.push_front(*argstr);
				}
				continue;
			}
		}

		if(b_firstArg && (*p == '-' || *p == '/' ))
		{
      		switch (toupper(*(p+1)))
			{
         		case 'Q':
            		b_queryDeletion=true;
					break;
				case 'R':
            		b_recourseDirectory=true;
					break;
				case 'S':
            		b_testMode=true;
					break;
				case '?':
            		usage();
					break;
				default:
            		break;
			}
			continue;
		}

		if(b_selectInclude)
		{
			b_selectInclude=false;
			strrev(a[i]);
			a[i][strlen(a[i]-2)]=NULL;
			strrev(a[i]);
		}

		if (b_firstArg)
		{
      	b_firstArg=false;
			strcpy(sz_currentPath,a[i]);
			continue;
		}

		string*	argstr = new string(a[i]);

		if (b_AND)
			IncludeList.push_front(*argstr);
		else
			ExcludeList.push_front(*argstr);
	}

	strupr(sz_currentPath);
	_splitpath(sz_currentPath,sz_drive,sz_dir,sz_name,sz_ext);

	if (*sz_name || *sz_ext)
	{
		strcpy(sz_path,sz_name);
		strcat(sz_path,sz_ext);

		IncludeList.push_front(*new string(sz_path));
	}

	strcpy(sz_path,sz_drive);
	strcat(sz_path,sz_dir);

	int ret=delFiles(sz_path);

	cout
   		<<	endl
   		<< "Action " << ((ret) ? "in" : "") << "complete!" << endl << endl
			<< "Total deleted : " << setw(6) << i_numOfMatch
			<< " files " << setw(8) << l_fileSel << " bytes"
			<< endl;

	SetConsoleCtrlHandler( NULL, FALSE);

	return (ret);
}

int main (int na, char** a)
{
	return	TMdel().main(na, a);
}

